#ifndef COMMON_H
#define COMMON_H

#include <windows.h>		// Header File For Windows
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library

#define BLOCK_SIZE 20

#define BLOCK_SPACING 1

#define WINDOW_WIDTH 800
#define WINDOW_HEIGHT 600

struct tRect
{
	union
	{
		struct
		{
			int m_iLeft, m_iRight;
			int m_iTop, m_iBottom;
		};

		int m_iSide[4];
	};

	tRect() {};
	virtual ~tRect() {};

	tRect(int x1, int x2, int y1, int y2)
	{
		m_iLeft = x1; m_iRight = x2;
		m_iTop = y1; m_iBottom = y2;
	};

	const tRect& operator = (const tRect& other)
	{
		m_iLeft = other.m_iLeft;
		m_iRight = other.m_iRight;
		m_iTop = other.m_iTop;
		m_iBottom = other.m_iBottom;

		return *this;
	};
	const int operator [] (int i)
	{
		if(i == 0)
			return m_iLeft;
		else if(i == 1)
			return m_iRight;
		else if(i == 2)
			return m_iTop;
		else if(i == 3)
			return m_iBottom;
	};

	unsigned int Width()
	{ return m_iRight - m_iLeft; };

	unsigned int Height()
	{ return m_iTop - m_iBottom; };
};

#endif