#include "TetrisBlock.h"

CTetrisBlock::CTetrisBlock()
{
	int num_blocks_x = WINDOW_WIDTH / (BLOCK_SIZE + BLOCK_SPACING);
	int num_blocks_y = WINDOW_HEIGHT / (BLOCK_SIZE + BLOCK_SPACING);

	m_iPosX = num_blocks_x / 2;
	m_iPosY = num_blocks_y - 1;
}

CTetrisBlock::~CTetrisBlock()
{
	Destroy();	
}

void CTetrisBlock::Create()
{

}

void CTetrisBlock::Draw()
{
	tRect quad;
	quad.m_iLeft = m_iPosX * (BLOCK_SIZE + BLOCK_SPACING) + BLOCK_SPACING;
	quad.m_iRight = quad.m_iLeft + BLOCK_SIZE - BLOCK_SPACING;
	quad.m_iTop = m_iPosY * (BLOCK_SIZE + BLOCK_SPACING) - BLOCK_SPACING;
	quad.m_iBottom = quad.m_iTop - BLOCK_SIZE + BLOCK_SPACING;

	glColor3d(1,1,1);
	glBegin(GL_QUADS);
	glVertex3f(quad.m_iLeft, quad.m_iBottom, 0);
	glVertex3f(quad.m_iRight, quad.m_iBottom, 0);
	glVertex3f(quad.m_iRight, quad.m_iTop, 0);
	glVertex3f(quad.m_iLeft, quad.m_iTop, 0);
	glEnd();
}


void CTetrisBlock::Destroy()
{

}

void CTetrisBlock::SetPosX(int x)
{
	m_iPosX = x;
}

void CTetrisBlock::SetPosY(int y)
{
	m_iPosY = y;
}

int CTetrisBlock::GetPosX()
{
	return m_iPosX;
}

int CTetrisBlock::GetPosY()
{
	return m_iPosY;
}