#include "TetrisFigure.h"

CTetrisFigure::CTetrisFigure()
{
	m_ppBlocks = NULL;
	m_iBlocksCount = 0;
}

CTetrisFigure::~CTetrisFigure()
{
	Destroy();
}

void CTetrisFigure::Create(int num_blocks)
{
	if(m_ppBlocks != NULL)
		Destroy();
	else
	{
		if(num_blocks > 0)
		{
			m_iBlocksCount = num_blocks;

			m_ppBlocks = new CTetrisBlock*[num_blocks];
			for (int i=0; i<num_blocks; i++)
				m_ppBlocks[i] = new CTetrisBlock;
		}
	}
}

void CTetrisFigure::Destroy()
{
	if(m_ppBlocks)
	{
		for (int i=0; i<m_iBlocksCount; i++)
		{
			if(m_ppBlocks[i] !=NULL)
				delete m_ppBlocks[i];
		}
		delete[] m_ppBlocks;
	}

	m_ppBlocks = NULL;
}

void CTetrisFigure::Draw()
{
	if(!m_ppBlocks)
		return;

	for (int i=0; i < m_iBlocksCount; i++)
	{
		if(m_ppBlocks[i] !=NULL)
			m_ppBlocks[i]->Draw();
	}
}


CTetrisBlock *CTetrisFigure::GetBlock(int x, int y)
{
	for (int i=0; i<m_iBlocksCount; i++)
	{
		if(m_ppBlocks[i] !=NULL)
		{
			if(m_ppBlocks[i]->GetPosX() == x && m_ppBlocks[i]->GetPosY() == y)
				return m_ppBlocks[i];
		}
	}

	return NULL;
}

CTetrisBlock *CTetrisFigure::GetBlock(int index)
{
	if(index >=0 && index < m_iBlocksCount)
		return m_ppBlocks[index];

	return NULL;
}

int CTetrisFigure::GetBlockCount()
{
	return m_iBlocksCount;
}


