#include "TetrisGame.h"

CTetrisGame::CTetrisGame()
{
	m_pCurrentFigure = NULL;
	m_pNextFigure = NULL;
	m_ppTetrisMatrix = NULL;

	m_iScore = 0;
	
}

CTetrisGame::~CTetrisGame()
{
	Destroy();
}


void CTetrisGame::Destroy()
{
	if(m_pCurrentFigure)
		m_pCurrentFigure = NULL;

	int num_blocks_x = WINDOW_WIDTH / (BLOCK_SIZE + BLOCK_SPACING);
	int num_blocks_y = WINDOW_HEIGHT / (BLOCK_SIZE + BLOCK_SPACING);

	if(m_pTemplateBlocks)
	{
		delete[] m_pTemplateBlocks;
		m_pTemplateBlocks = NULL;
	}

	if(m_pTemplateFigures)
	{
		delete[] m_pTemplateFigures;
		m_pTemplateFigures = NULL;
	}


	if(m_ppTetrisMatrix)
	{
		for (int y=0; y<num_blocks_y; y++)
		{
			delete[] m_ppTetrisMatrix[y];
			m_ppTetrisMatrix[y] = NULL;
		}

		delete[] m_ppTetrisMatrix;
		m_ppTetrisMatrix = NULL;

	}

	m_iScore = 0;
}

void CTetrisGame::Draw()
{
	int num_blocks_x = WINDOW_WIDTH / (BLOCK_SIZE + BLOCK_SPACING);
	int num_blocks_y = WINDOW_HEIGHT / (BLOCK_SIZE + BLOCK_SPACING);

	for (int i=0; i<num_blocks_y; i++)
	{
		for (int j=0; j<num_blocks_x; j++)
		{
			if(m_ppTetrisMatrix[i][j] !=NULL)
				m_ppTetrisMatrix[i][j]->Draw();
		}
	}
}

void CTetrisGame::Create()
{
	int num_blocks_x = WINDOW_WIDTH / (BLOCK_SIZE + BLOCK_SPACING);
	int num_blocks_y = WINDOW_HEIGHT / (BLOCK_SIZE + BLOCK_SPACING);
	
	m_ppTetrisMatrix = new CTetrisBlock**[num_blocks_y];

	for (int i=0; i<num_blocks_y; i++)
	{
		m_ppTetrisMatrix[i] = new CTetrisBlock*[num_blocks_x];
		for (int j=0; j<num_blocks_x; j++)
			m_ppTetrisMatrix[i][j] = NULL;
	}
}

void CTetrisGame::MapFigure(CTetrisFigure *figure, bool assign)
{
	for (int i=0; i<figure->GetBlockCount(); i++)
	{
		if(assign)
		{
			if(figure->GetBlock(i) !=NULL)	
				m_ppTetrisMatrix[figure->GetBlock(i)->GetPosY()][figure->GetBlock(i)->GetPosX()] = figure->GetBlock(i);
		}
		else
		{
			if(figure->GetBlock(i) !=NULL)	
				m_ppTetrisMatrix[figure->GetBlock(i)->GetPosY()][figure->GetBlock(i)->GetPosX()] = NULL;
		}
	}
}
